<script setup lang="ts">
import type { BaseLink } from '@/types/base';
import { ref, onMounted } from 'vue';

type StickyNavProps = {
  links: BaseLink[];
  config: {
    dark?: boolean;
  };
};

const props = defineProps<StickyNavProps>();
const activeLink = ref<InstanceType<typeof BaseLink> | null>(null);
const sticky = ref(false);
const navbar = ref<InstanceType<typeof HTMLElement> | null>(null);
const navBarHeight = ref(56); // navbar height default
const handleScroll = () => {
  if (navbar.value) {
    const stickyOffset = navbar.value.offsetTop;
    sticky.value = window.pageYOffset > stickyOffset - 84; // 84px offset
  }
  updateActiveLink();
};
const updateActiveLink = () => {
  const scrollPosition = window.scrollY + 84;
  props.links.forEach((link) => {
    const section = document.querySelector(link.config.href) as HTMLElement;
    if (section) {
      section.style.scrollMarginTop = `-${navBarHeight.value}px`;
      const sectionTop = section.offsetTop;
      const sectionHeight = section.offsetHeight;

      if (scrollPosition >= sectionTop && scrollPosition < sectionTop + sectionHeight) {
        activeLink.value = link.config.href;
      }
    }
  });
};
onMounted(() => {
  navBarHeight.value = navbar.value ? navbar.value.getBoundingClientRect().height : navBarHeight.value;
  window.addEventListener('scroll', handleScroll);
  updateActiveLink();
});
</script>

<template>
  <div>
    <nav ref="navbar" class="sticky-nav" :class="{ sticky: sticky, 'sticky-nav--dark': config?.dark }">
      <ul class="sticky-nav__ul">
        <li
          v-for="link in links"
          :key="link.text"
          class="sticky-nav__li"
          :class="{ active: activeLink === link.config.href }"
        >
          <a
            :href="link.config.href"
            :data-ga-location="link.config.dataGaLocation"
            :data-ga-name="link.config.dataGaName"
            >{{ link.text }}</a
          >
        </li>
      </ul>
    </nav>
  </div>
</template>

<style lang="scss" scoped>
.sticky-nav {
  padding: $spacing-16 0;
  transition: all 0.3s ease;
  z-index: 100;
  background-color: #fff;
  &__ul {
    list-style: none;
    padding: 0;
    margin: 0;
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    @media (max-width: $breakpoint-sm) {
      flex-wrap: nowrap;
      justify-content: flex-start;
      overflow-x: scroll;
    }
  }
  &__li {
    margin: 0 $spacing-16;
    &.active {
      a {
        font-weight: 600;
        color: $color-accent-400;
        border-bottom: 1px solid $color-accent-400;
      }
    }
  }
  a {
    text-decoration: none;

    &:hover {
      text-decoration: none;
      border-bottom: 1px solid $color-accent-400;
    }
  }
  &.sticky {
    position: fixed;
    top: 84px;
    width: 100%;
    @media (max-width: $breakpoint-sm) {
      top: 116px;
    }
  }
  &--dark {
    background-color: $color-surface-700;
    a {
      color: $color-text-50;
    }
    &.active {
      a {
        color: $color-accent-400;
      }
    }
  }
}
</style>
